#!/usr/bin/env python

try:
    from distutils.core import setup,Extension
    from distutils.command.build_ext import build_ext
    from distutils.errors import CCompilerError    
    from distutils.command.build_ext import build_ext
    #from distutils.command.install_data import install_data
  
    
except:
    print "Unable to import python distutils."
    print "You may want to install the python-dev package on your distribution."
    print "If you don't want to do so, you may as well just leave the extracted package where it is, and make a symbolic link from ./imgSeek to the place you store binary files."
    sys.exit(1)
try:
    import sys
    import imgSeekLib
except:
    print "Unable to load crucial imgSeekLib module."
    print "Unable to continue installation. You may just leave the extracted package where it is, and make a symbolic link from ./imgSeek to the place you store binary files."
    sys.exit(1)
# guess python include dir
include_dirs = ["/usr/include/python2.2"]
imgSeekLib.failedbuild=0
class fallible_build_ext(build_ext):
  def run(self):
    try:
      build_ext.run(self)
    except CCompilerError:
      imgSeekLib.failedbuild=1
      print """
Unable to compile and install the haar C extension for speeding up the addition of files to database.
It is strongly recommended that you install the python-dev (python-devel on some distributions) package for your GNU/Linux distribution, and then try \"python setup.py install\" again.
"""
    
setup(name="imgSeek",
      version=imgSeekLib.__version__,
      description="imgSeek photo collection manager",
      long_description ="""imgSeek is a photo collection manager capable of searching through an image database, in which the query is expressed either as a rough sketch painted by the user or as another image you supply (or an image in your collection) The searching algorithm makes use of multiresolution wavelet decompositions of the query and database images.""",      
      author="Ricardo Niederberger Cabral",
      author_email="nieder@mail.ru",
      url="http://imgseek.sourceforge.net/",
      platforms = ['Linux'],
      cmdclass = { 'build_ext': fallible_build_ext},
      
      licence = 'GPL2',
      data_files = [
        ('imgSeekLib/styles/Acqua',[
                       'imgSeekLib/styles/Acqua/aq.css',
                       'imgSeekLib/styles/Acqua/aq_background.gif',
                       'imgSeekLib/styles/Acqua/coininfd.gif',
                       'imgSeekLib/styles/Acqua/coininfg.gif',
                       'imgSeekLib/styles/Acqua/coinsupd.gif',
                       'imgSeekLib/styles/Acqua/coinsupg.gif',
                       'imgSeekLib/styles/Acqua/d.gif',
                       'imgSeekLib/styles/Acqua/fond.gif',
                       'imgSeekLib/styles/Acqua/g.gif',
                       'imgSeekLib/styles/Acqua/inf.gif',
                       'imgSeekLib/styles/Acqua/space15_15.gif',
                       'imgSeekLib/styles/Acqua/sup.gif'])],
      packages=['imgSeekLib'],      
      scripts= ['imgSeek'],
      ext_modules = [
        Extension("imgSeekLib.haar",["imgSeekLib/haar.c"],
                  include_dirs = include_dirs
                 )]
     )
if imgSeekLib.failedbuild:
      print """Warning:\n
Unable to compile and install the haar C extension for speeding up the addition of files to database.
It is strongly recommended that you install the python-dev (python-devel on some distributions) package for your GNU/Linux distribution, and then try \"python setup.py install\" again.
"""
else:
    print "\nimgSeek install complete.\nRun it with \"imgSeek\"\n"
